// Code generated by Wire. DO NOT EDIT.

//go:generate wire
//+build !wireinject

package main

import (
	"context"
	"github.com/aws/aws-sdk-go/aws"
	"github.com/aws/aws-sdk-go/aws/client"
	"github.com/aws/aws-sdk-go/aws/credentials"
	"github.com/aws/aws-sdk-go/aws/session"
	"github.com/google/go-cloud/health"
	"github.com/google/go-cloud/server"
	"github.com/google/go-cloud/server/xrayserver"
	"github.com/google/go-cloud/wire"
	"go.opencensus.io/trace"
)

// Injectors from inject.go:

func initialize(ctx context.Context, cfg *appConfig) (*server.Server, func(), error) {
	ncsaLogger := xrayserver.NewRequestLogger()
	v := _wireValue
	options := awsOptions(cfg)
	sessionSession, err := session.NewSessionWithOptions(options)
	if err != nil {
		return nil, nil, err
	}
	xRay := xrayserver.NewXRayClient(sessionSession)
	exporter, cleanup, err := xrayserver.NewExporter(xRay)
	if err != nil {
		return nil, nil, err
	}
	sampler := trace.AlwaysSample()
	serverOptions := &server.Options{
		RequestLogger:         ncsaLogger,
		HealthChecks:          v,
		TraceExporter:         exporter,
		DefaultSamplingPolicy: sampler,
	}
	serverServer := server.New(serverOptions)
	return serverServer, func() {
		cleanup()
	}, nil
}

var (
	_wireValue = []health.Checker{connection}
)

// inject.go:

var awsSession = wire.NewSet(session.NewSessionWithOptions, awsOptions, wire.Bind((*client.ConfigProvider)(nil), (*session.Session)(nil)), configConfidentials)

func awsOptions(cfg *appConfig) session.Options {
	return session.Options{
		Config: aws.Config{
			Region: aws.String(cfg.region),
		},
	}
}

func configConfidentials(cfg *aws.Config) *credentials.Credentials {
	return cfg.Credentials
}
